#include "mode3.h"
#include "bios_arm.h"


//---------------------------------------------------------------------------
ST_MODE3 Mode3 EWRAM_BSS;


//---------------------------------------------------------------------------
EWRAM_CODE void Mode3Init(void)
{
	BiosExecFixClear(&Mode3, sizeof(ST_MODE3));

	REG_DISPCNT = MODE_3 | BG2_ON;
}
//---------------------------------------------------------------------------
IWRAM_CODE void Mode3Exec(void)
{
	if(Mode3.isDraw == TRUE)
	{
		BiosExecFast(Mode3.bg, (u16*)VRAM, MODE3_MAX_BUF_SIZE);
		Mode3.isDraw = FALSE;
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void Mode3DrawLine(s32 x1, s32 y1, s32 x2, s32 y2, u16 col)
{
	s32 dx, dy;
	s32 sx, sy;
	s32 x, y;
	s32 E;
	s32 i;

	sx = ( x2 > x1 ) ? 1 : -1;
	dx = ( x2 > x1 ) ? x2 - x1 : x1 - x2;
	sy = ( y2 > y1 ) ? 1 : -1;
	dy = ( y2 > y1 ) ? y2 - y1 : y1 - y2;

	x = x1;
	y = y1;

	if(dx >= dy)
	{
		//X1ȉ̏ꍇ
		E = -dx;

		for(i=0; i<=dx; i++)
		{
			Mode3.bg[x + (y * SCREEN_WIDTH)] = col;

			x += sx;
			E += 2 * dy;

			if(E >= 0)
			{
				y += sy;
				E -= 2 * dx;
			}
		}
	}
	else
	{
		//X1傫ꍇ
		E = -dy;
		
		for(i=0; i<=dy; i++)
		{
			Mode3.bg[x + (y * SCREEN_WIDTH)] = col;

			y += sy;
			E += 2 * dx;

			if(E >= 0)
			{
				x += sx;
				E -= 2 * dy;
			}
		}
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void Mode3DrawClear(void)
{
	BiosExecFastFixClear(Mode3.bg, MODE3_MAX_BUF_SIZE);
}
//---------------------------------------------------------------------------
IWRAM_CODE void Mode3SetDraw(bool isDraw)
{
	Mode3.isDraw = isDraw;
}
