#include "line.h"
#include "libmy/mt.h"
#include "libmy/mode3.h"


//---------------------------------------------------------------------------
ST_LINE Line[LINE_CNT];


//---------------------------------------------------------------------------
EWRAM_CODE void LineInit(void)
{
	_Memset(&Line, 0x00, sizeof(ST_LINE) * LINE_CNT);


	u32 i;

	for(i=0; i<LINE_CNT; i++)
	{
		LineInitSub(&Line[i]);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void LineInitSub(ST_LINE* p)
{
	s32 vx, vy;
	s32 r;

	for(r=0; r<LINE_REFERENCE_CNT; r++)
	{
		// V`_
		p->x[r][0] = MtRand(SCREEN_WIDTH);
		p->y[r][0] = MtRand(SCREEN_HEIGHT);

		// x
		vx = MtRand(15) - 7;
		vy = MtRand(15) - 7;

		if(vx == 0)
		{
			vx = (MtRand(2) == 0) ? 1 : -1;
		}
		if(vy == 0)
		{
			vy = (MtRand(2) == 0) ? 1 : -1;
		}

		p->vx[r] = vx;
		p->vy[r] = vy;
	}

	p->col = RGB5(31, 31, 31);
}
//---------------------------------------------------------------------------
IWRAM_CODE void LineExec(void)
{
	Mode3DrawClear();
	Mode3SetDraw(TRUE);


	u32 i;

	for(i=0; i<LINE_CNT; i++)
	{
		LineDraw(&Line[i]);
		LineMove(&Line[i]);
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void LineDraw(ST_LINE* p)
{
	s32 a, r;

	for(a=0; a<p->moveCnt; a++)
	{
		for(r=0; r<LINE_REFERENCE_CNT-1; r++)
		{
			Mode3DrawLine(p->x[r][a], p->y[r][a], p->x[r+1][a], p->y[r+1][a], p->col);
		}

		Mode3DrawLine(p->x[0][a], p->y[0][a], p->x[r][a], p->y[r][a], p->col);
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void LineMove(ST_LINE* p)
{
	s32 a, r;

	// c̃Rs[
	for(a=LINE_AFTER_CNT-1; a>0; a--)
	{
		for(r=0; r<LINE_REFERENCE_CNT; r++)
		{
			p->x[r][a] = p->x[r][a-1];
			p->y[r][a] = p->y[r][a-1];
		}
	}

	// V`_Ƒx߂܂
	s32 nx, ny;

	for(r=0; r<LINE_REFERENCE_CNT; r++)
	{
		nx = p->x[r][0] + p->vx[r];
		ny = p->y[r][0] + p->vy[r];

		// x
		if(nx < 0)
		{
			nx = 0;
			p->vx[r] = MtRand(7) + 1;
		}
		if(nx >= SCREEN_WIDTH)
		{
			nx = SCREEN_WIDTH - 1;
			p->vx[r] = -1 * (MtRand(7) + 1);
		}

		// y
		if(ny < 0)
		{
			ny = 0;
			p->vy[r] = MtRand(7) + 1;
		}
		if(ny >= SCREEN_HEIGHT)
		{
			ny = SCREEN_HEIGHT - 1;
			p->vy[r] = -1 * (MtRand(7) + 1);
		}

		p->x[r][0] = nx;
		p->y[r][0] = ny;
	}

	if(p->moveCnt < LINE_AFTER_CNT)
	{
		p->moveCnt++;
	}
}
